Loading...
Searching...
No Matches
Dune::TypeTree::ProxyNodeBase< Node, DynamicPowerNodeTag > Struct Template Reference
dune-typetree » Nodes

ProxyNode base class for DynamicPowerNode. More...

`#include <dune/typetree/proxynode.hh>`

Inheritance diagram for Dune::TypeTree::ProxyNodeBase< Node, DynamicPowerNodeTag >:

## Public Types

typedef Node::ChildType | ChildType
typedef Node::NodeStorage | NodeStorage

## Public Member Functions

Child Access (Dynamic methods)
auto & | child (std::size_t i)
| Returns the i-th child.
auto | childStorage (std::size_t i)
| Returns the storage of the i-th child.
void | setChild (std::size_t i, ProxyChild &&child, typename std::enable_if< enabled, void * >::type=0)
| Sets the i-th child to the passed-in value.
Child Access
auto & | child (index_constant< k >={})
| Returns the i-th child.
const auto & | child (index_constant< k >={}) const
| Returns the i-th child (const version).
auto | childStorage (index_constant< k >={})
| Returns the storage of the i-th child.
auto | childStorage (index_constant< k >={}) const
| Returns the storage of the i-th child (const version).
void | setChild (ProxyChild &&child, typename std::enable_if< lazy_enabled< k >::value, void * >::type=0)
| Sets the i-th child to the passed-in value.
const Node::NodeStorage & | nodeStorage () const

## Detailed Description

template<typename Node>
struct Dune::TypeTree::ProxyNodeBase< Node, DynamicPowerNodeTag >

ProxyNode base class for DynamicPowerNode.

## Member Typedef Documentation

## ChildType

template<typename Node>

typedef Node::ChildType Dune::TypeTree::ProxyNodeBase< Node, DynamicPowerNodeTag >::ChildType

## NodeStorage

template<typename Node>

typedef Node::NodeStorage Dune::TypeTree::ProxyNodeBase< Node, DynamicPowerNodeTag >::NodeStorage

## Member Function Documentation

## child() [1/3]

auto & Dune::TypeTree::StaticChildAccessors< Node >::child | ( | index_constant< k > | = {} | ) |

inline inherited

Returns the i-th child.

Returns
  a reference to the i-th child.

## child() [2/3]

const auto & Dune::TypeTree::StaticChildAccessors< Node >::child | ( | index_constant< k > | = {} | ) | const

inline inherited

Returns the i-th child (const version).

Returns
  a const reference to the i-th child.

## child() [3/3]

auto & Dune::TypeTree::DynamicChildAccessors< Node >::child | ( | std::size_t | i | ) |

inline inherited

Returns the i-th child.

Returns
  a reference to the i-th child.

## childStorage() [1/3]

auto Dune::TypeTree::StaticChildAccessors< Node >::childStorage | ( | index_constant< k > | = {} | ) |

inline inherited

Returns the storage of the i-th child.

Returns
  a copy of the object storing the i-th child.

## childStorage() [2/3]

auto Dune::TypeTree::StaticChildAccessors< Node >::childStorage | ( | index_constant< k > | = {} | ) | const

inline inherited

Returns the storage of the i-th child (const version).

This method is only important if the child is stored as some kind of pointer, as this allows the pointee type to become const.

Returns
  a copy of the object storing the i-th child.

## childStorage() [3/3]

auto Dune::TypeTree::DynamicChildAccessors< Node >::childStorage | ( | std::size_t | i | ) |

inline inherited

Returns the storage of the i-th child.

Returns
  a copy of the object storing the i-th child.

## nodeStorage()

const Node::NodeStorage & Dune::TypeTree::StaticChildAccessors< Node >::nodeStorage | ( |  | ) | const

inline inherited

## setChild() [1/2]

void Dune::TypeTree::StaticChildAccessors< Node >::setChild | ( | ProxyChild && | child,
|  | typename std::enable_if< lazy_enabled< k >::value, void * >::type | = 0 )

inline inherited

Sets the i-th child to the passed-in value.

## setChild() [2/2]

void Dune::TypeTree::DynamicChildAccessors< Node >::setChild | ( | std::size_t | i,
|  | ProxyChild && | child,
|  | typename std::enable_if< enabled, void * >::type | = 0 )

inline inherited

Sets the i-th child to the passed-in value.

The documentation for this struct was generated from the following file:

- proxynode.hh